'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = wrapMcsComponent;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function wrapMcsComponent(store, UiComponent) {
  var _class, _temp;

  var invoke = store.invoke.bind(store);
  var bind = store.bind.bind(store);

  return _temp = _class = function (_Component) {
    _inherits(McsComponent, _Component);

    function McsComponent(props) {
      _classCallCheck(this, McsComponent);

      var _this = _possibleConstructorReturn(this, _Component.call(this, props));

      _this.state = {
        mcs: {
          invoke: invoke,
          bind: bind
        }
      };

      _this.ctrls = store.getCtrls(props.ctrls);
      return _this;
    }

    McsComponent.prototype.componentDidMount = function componentDidMount() {
      var _this2 = this;

      var ctrls = store.getCtrls(this.props.ctrls);
      ctrls.forEach(function (ctrl) {
        ctrl.onComputeDone(function () {
          var nextState = { mcs: _this2.state.mcs };
          nextState.mcs[ctrl.getName()] = ctrl.state;
          _this2.setState(nextState);
        });
      });
    };

    McsComponent.prototype.render = function render() {
      return _react2['default'].createElement(UiComponent, _extends({}, this.state, this.props));
    };

    return McsComponent;
  }(_react.Component), _class.displayName = (UiComponent.displayName || UiComponent.name) + 'MscWrapper', _class.proptypes = {
    ctrls: _react.PropTypes.arrayOf(_react.PropTypes.string.isRequired)
  }, _temp;
}