import EventEmitter from 'eventemitter3'

export default class Model {

  initState = {}

  constructor() {
    this.ee = new EventEmitter()
    this.state = {
      ...this.initState,
      __setStateCounter: 0
    }
  }

  on(event, listener) {
    this.ee.on(event, listener)
  }

  setState(nextState) {
    const prevState = this.state
    const state = {
      ...prevState,
      ...nextState,
      __setStateCounter: prevState.__setStateCounter + 1
    }
    this.ee.emit('beforeUpdate', prevState, state)
    this.state = state
    this.ee.emit('didUpdate', state, prevState)
  }

  compute() {
  }
}