import React, {PropTypes, Component} from 'react'

export default function wrapMcsComponent(store, UiComponent) {
  const invoke = store.invoke.bind(store)
  const bind = store.bind.bind(store)

  return class McsComponent extends Component {
    static displayName = `${UiComponent.displayName || UiComponent.name}MscWrapper`
    static proptypes = {
      ctrls: PropTypes.arrayOf(PropTypes.string.isRequired)
    }
    state = {
      mcs: {
        invoke,
        bind
      }
    }
    constructor(props) {
      super(props)
      this.ctrls = store.getCtrls(props.ctrls)
    }
    componentDidMount() {
      const ctrls = store.getCtrls(this.props.ctrls)
      ctrls.forEach((ctrl) => {
        ctrl.onComputeDone(() => {
          const nextState = {mcs: this.state.mcs}
          nextState.mcs[ctrl.getName()] = ctrl.state
          this.setState(nextState)
        })
      })
    }
    render() {
      return <UiComponent {...this.state} {...this.props}/>
    }
  }
}
